<template>
    <div class="card columns">
      <div class="card-header">
        <h3>User Profile</h3>
      </div>
      <div class="card-body">
        <div class="row">
          <div class=" col-md-3 d-flex justify-content-center">
          <userImage :user="user" size="lg">
            <template slot="underImage">
              <label class="btn btn-sm btn-info mt-2 w-80">
                Set Image
                <input type="file" style="display: none;" @change="uploadImage($event)">
              </label>
            </template>
          </userImage>
          </div>
          <div class="col-sm-9 mt-4">
            <form>
              <div class="form-group row">
                <div class="col-sm-3 col-lg-2">
                  <label for="Name" class="col-form-label">Name</label>
                </div>
                <div class="col-sm-9 col-lg-10 input-group p-0">
                  <span class="btn m-0" v-if="editName">
                    <font-awesome-icon
                      color="darkgreen"
                      icon="check"
                      data-trigger="hover | focus"
                      data-toggle="popover"
                      data-content="Auto Log off will be applied"
                      title="Send changes"
                      data-placement="left"
                      @click.stop="updateUser()"
                    />
                  </span>
                  <span class="btn m-0"  v-if="!editName">
                    <font-awesome-icon
                      color="rgb(5, 5, 110)"
                      icon="edit"
                      data-trigger="hover | focus"
                      data-toggle="popover"
                      data-content="Edit name"
                      data-placement="left"
                      @click.stop="edit('Name')"
                    />
                  </span>
                  <input
                    :disabled="!editName"
                    autofocus
                    type="text"
                    ref="inputName"
                    class="form-control p-0 input-border-less m-0 col-sm-12 col-md-8 col-lg-6"
                    v-model="newName"
                    @blur="focusLost('Name')"
                  >
                </div>
              </div>
              <div class="form-group row">
                <div class="col-sm-3 col-lg-2">
                  <label for="Email" class="col-form-label">Email</label>
                </div>
                <div class="col-8 col-md-9 col-lg-10 input-group p-0">
                  <span class="btn m-0" v-if="editMail">
                    <font-awesome-icon
                      color="darkgreen"
                      icon="check"
                      data-trigger="hover | focus"
                      data-toggle="popover"
                      data-content="Auto Log off will be applied"
                      data-title="Send changes"
                      data-placement="left"
                      @click.stop="updateUser()"
                    />
                  </span>
                  <span class="btn m-0"  v-if="!editMail">
                    <font-awesome-icon
                      color="rgb(5, 5, 110)"
                      icon="edit"
                      data-trigger="hover | focus"
                      data-toggle="popover"
                      data-content="Edit email"
                      data-placement="left"
                      @click.stop="edit('Mail')"
                    />
                  </span>
                  <input
                    :disabled="!editMail"
                    autofocus
                    type="text"
                    ref="inputMail"
                    class="form-control p-0 input-border-less m-0 col-sm-12 col-md-8 col-lg-6"
                    v-model="newMail"
                    @blur="focusLost('Mail')"
                  >
                </div>
              </div>
                <div class="form-group row">
                <div class="col-sm-3 col-lg-2">
                  <label for="Name" class="col-form-label">Password</label>
                </div>
                <div class="col-sm-9 col-lg-10 input-group p-0">
                  <span class="btn m-0" v-if="editPass || enteringPass">
                    <font-awesome-icon
                      color="darkgreen"
                      icon="check"
                      data-trigger="focus | hover"
                      data-toggle="popover"
                      data-content="Auto Log off will be applied"
                      title="Send changes"
                      data-placement="left"
                      @click.stop="pass()"
                    />
                  </span>
                  <span class="btn m-0"  v-if="!editPass && !enteringPass">
                    <font-awesome-icon
                      color="rgb(5, 5, 110)"
                      icon="edit"
                      data-trigger="hover | focus"
                      data-toggle="popover"
                      data-content="Edit Password"
                      data-placement="left"
                      @click.stop="edit('Password')"
                    />
                  </span>
                  <input
                    v-if="!passInserted"
                    :disabled="!editPass"
                    autofocus
                    :placeholder="enteringPass"
                    type="password"
                    ref="inputPassword"
                    class="form-control p-0 input-border-less m-0 col-sm-12 col-md-8 col-lg-6"
                    v-model="newPass"
                  >
                  <input
                    v-if="passInserted"
                    autofocus
                    :placeholder="enteringPass"
                    type="password"
                    ref="inputConfPass"
                    class="form-control p-0 input-border-less m-0 col-sm-12 col-md-8 col-lg-6"
                    v-model="confNewPass"
                  >
                </div>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>
</template>
<script>
import userImage from '../userImage'
export default {
  props:["user"],
  components:{
    userImage
  },
  data (){
    return{
      editName : false,
      editMail : false,
      editPass: false,
      passInserted:false,
      newName : this.user.name,
      newMail: this.user.email,
      newPass:null,
      confNewPass:null,
      userImage,
    }
  },
  mounted:function(){
    this.$socket.on('resUpdateUser',data=>{
      if(data.newName){
        this.$toastr.error(data.newName+ 'is not a valid name',
        "Request error", {
          preventDuplicates: true,
          progressBar: true,
          positionClass: 'toast-bottom-right',
        });
      }else{
        this.$toastr.error(data.newMail+ 'is already in use',
        "Request error", {
          preventDuplicates: true,
          progressBar: true,
          positionClass: 'toast-bottom-right',
        });
      }
    })
  },
  computed:{
    enteringPass:function(){
      if(this.editPass){
         return 'New Password'
      }else if(this.passInserted){
        return 'Confirm Password'
      }
      else return ''
    }
  },
  methods:{
     edit: function(element){
      if (element=="Name"){
      this.editName=true
      setTimeout(()=>{ //is necesary, else recives focus before set active
        this.$refs.inputName.focus();
      },1)
      }else if(element=="Mail"){
        this.editMail=true
        setTimeout(()=>{ //is necesary, else recives focus before set active
        this.$refs.inputMail.focus();
      },1)
      }else if(!this.editPass){
          this.editPass=true
          setTimeout(()=>{ //is necesary, else recives focus before set active
           this.$refs.inputPassword.focus();
        },1)
      }
    },
      focusLost:function(element){
        if(element=='Name'){
          setTimeout(()=>{
            this.newName=this.user.name
            this.editName=false
            },100)
        }else if(element=='Mail'){
          setTimeout(()=>{
            this.newMail=this.user.email
            this.editMail=false
          },100)
        }
      },
      updateUser:function(){
        if(this.validate_email(this.newMail)){
        var data={
          user: this.user,
          token: localStorage.getItem("jwt"),
          newName:null,
          newMail:null,
          newPass:null
        }
        if(this.newName!=this.user.name) {
          data.newName= this.newName
          this.$socket.emit('reqUpdateUser',data)
        }
        else if(this.newMail!=this.user.email){
           data.newMail= this.newMail
           this.$socket.emit('reqUpdateUser',data)
        }else {
          data.newPass=this.newPass
          this.$socket.emit('reqUpdateUser',data)
        }
      }else{
        this.$toastr.error(this.newMail+ ' is not a valid email',
        "Request error", {
          preventDuplicates: true,
          progressBar: true,
          positionClass: 'toast-bottom-right',
        });
      }
      },
    async uploadImage(e){
        var files = e.target.files || e.dataTransfer.files;
        if(files.length) {
          var image=await this.getBase64(files[0])
          this.$socket.emit('uploadUserImage',{
            user: this.user,
            token: localStorage.getItem("jwt"),
            image:image
          })
        }
    },
    pass(){
      if(this.editPass){
        if(this.newPass!=null && this.newPass!=''){
          this.editPass=false
          this.passInserted=true
          setTimeout(()=>{
            this.$refs.inputConfPass.focus();
          },1)
        }else{
          setTimeout(()=>{
            this.$refs.inputPassword.focus();
          },1)
          this.$toastr.error('Empty password field',
          "Request error", {
          preventDuplicates: true,
          progressBar: true,
          positionClass: 'toast-bottom-right',
        });
        }
      }else{
          if(this.newPass==this.confNewPass){
            this.updateUser()
          }else{
            this.newPass=null,
            this.confNewPass=null,
            this.passInserted=false,
            this.$toastr.error('Password fields do not match',
              "Request error", {
              preventDuplicates: true,
              progressBar: true,
              positionClass: 'toast-bottom-right',
          });
          }
        }
    },
    validate_email(email) {
      var regex = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
      return regex.test(email) ? true : false;
    },
    getBase64(file) {
      return new Promise((resolve, reject) => {
      const reader = new FileReader();
      reader.readAsDataURL(file);
      reader.onload = () => {
        let encoded = reader.result.replace(/^data:(.*;base64,)?/, '');
        if ((encoded.length % 4) > 0) {
          encoded += '='.repeat(4 - (encoded.length % 4));
        }
        resolve(encoded);
      };
      reader.onerror = error => reject(error);
    });
}
    },
  }

</script>
<style scoped>
  .input-border-less {
     border-bottom-width: 0px !important;
  }
  input[type="text"]:disabled {
  background: transparent;
}
  input[type="password"]:disabled {
  background: transparent;
}
</style>
